//+------------------------------------------------------------------+
//|                                             .mq4 |
//|                                                    .. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright " .."
#property link      "http://www.metaquotes.net"

extern double TakeProfit = 800;
extern double Lots = 0.2;
extern double TrailingStop = 30;
extern double StopLoss = 40;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double MaCurrent5, MaPrevious5, MaCurrent20, MaPrevious20, MaCurrent200, MaPrevious200;
   double MaCurrent5D, MaPrevious5D, MaCurrent20D, MaPrevious20D, MaCurrent200D, MaPrevious200D;
   
   double StochasticMainBufferCurrent ,StochasticSignalBufferCurrent ,StochasticMainBufferPrevious ,StochasticSignalBufferPrevious;
   double StochasticMainBufferCurrentD ,StochasticSignalBufferCurrentD ,StochasticMainBufferPreviousD ,StochasticSignalBufferPreviousD;
   
   double MacdCurrent, MacdPrevious, SignalCurrent,SignalPrevious;
   double MacdCurrentD, MacdPreviousD, SignalCurrentD ,SignalPreviousD;
   
   
   double  MaCurrent, MaPrevious ,MaCurrentD5, MaPreviousD5 ,MaCurrentD20, MaPreviousD20 ,MaCurrentD200, MaPreviousD200;
   
   double  ROCCurrent, ROCPrevious;
   double  ROCCurrentD, ROCPreviousD;
   //double val=iCustom (NULL, PERIOD_D1, "ROC",5,1,0);
   
   //double iCustom (NULL, PERIOD_H1, "ROC",5,1,0);
   
   int cnt, ticket, total, tr, day;
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print(",   100");//bars less than 100
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("    10"); //TakeProfit less than 10
      return(0);  // check TakeProfit
     }
// to simplify the coding and speed up access
// data are put into internal variables
   MaCurrent5=iMA(NULL,0,5,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious5=iMA(NULL,0,5,0,MODE_SMA,PRICE_CLOSE,1);
   MaCurrent20=iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious20=iMA(NULL,0,20,0,MODE_SMA,PRICE_CLOSE,1);
   MaCurrent200=iMA(NULL,0,200,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious200=iMA(NULL,0,200,0,MODE_SMA,PRICE_CLOSE,1);
   
   MaCurrent5D=iMA(NULL,PERIOD_D1,5,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious5D=iMA(NULL,PERIOD_D1,5,0,MODE_SMA,PRICE_CLOSE,1);
   MaCurrent20D=iMA(NULL,PERIOD_D1,20,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious20D=iMA(NULL,PERIOD_D1,20,0,MODE_SMA,PRICE_CLOSE,1);
   MaCurrent200D=iMA(NULL,PERIOD_D1,200,0,MODE_SMA,PRICE_CLOSE,0);
   MaPrevious200D=iMA(NULL,PERIOD_D1,200,0,MODE_SMA,PRICE_CLOSE,1);

   MacdCurrent=iMACD(NULL,0,5,20,3,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious=iMACD(NULL,0,5,20,3,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrent=iMACD(NULL,0,5,20,3,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious=iMACD(NULL,0,5,20,3,PRICE_CLOSE,MODE_SIGNAL,1);
   
   MacdCurrentD=iMACD(NULL,PERIOD_D1,5,20,3,PRICE_CLOSE,MODE_MAIN,0);
   MacdPreviousD=iMACD(NULL,PERIOD_D1,5,20,3,PRICE_CLOSE,MODE_MAIN,1);
   SignalCurrentD=iMACD(NULL,PERIOD_D1,5,20,3,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPreviousD=iMACD(NULL,PERIOD_D1,5,20,3,PRICE_CLOSE,MODE_SIGNAL,1);
   
   StochasticMainBufferCurrent=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   StochasticMainBufferPrevious=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   StochasticSignalBufferCurrent=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   StochasticSignalBufferPrevious=iStochastic(NULL,0,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   
   StochasticMainBufferCurrentD=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   StochasticMainBufferPreviousD=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   StochasticSignalBufferCurrentD=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_SMA,0,MODE_MAIN,0);
   StochasticSignalBufferPreviousD=iStochastic(NULL,PERIOD_D1,5,3,3,MODE_SMA,0,MODE_MAIN,1);
   
   ROCCurrentD=iCustom (NULL, PERIOD_D1, "ROC",5,1,0);
   ROCPreviousD=iCustom (NULL, PERIOD_D1, "ROC",5,1,1);
   //ROCCurrent=iCustom (NULL, 0, "ROC",5,1,0);
   //ROCPrevious=iCustom (NULL, 0, "ROC",5,1,1);
   
   //if ((MacdCurrent>0 && MacdPrevious<0)||(MacdCurrent<0 && MacdPrevious>0)) 
   //{
   //Trading=1;
 //  Print("   MACD ");
   //}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  //   
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   total=OrdersTotal();
   //tr=iBarShift();
   day=Day();
//   datetime some_time=D'2004.03.21 12:00';
//  int      shift=iBarShift("EUROUSD",PERIOD_D1,some_time);
//  Print("shift of bar with open time ",TimeToStr(some_time)," is ",shift);
   
   
  // void start()
{
  static int Pbars=0;

  if (Pbars == Bars) return(0);  
  Pbars = Bars;

  //  ))))
}
   
   
   
int flag=1;
   if(total<1) 
     {
      //   
      if (AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      
     // if (MathAbs(Bid-Ask)>0.0005) 
      //if (MathAbs(Bid-Ask)>100.01)
     // {
     // flag=0; 
      //Print(" =",MathAbs(Bid-Ask),"  !");
    //  }
      //  
         //if(iBar ())
      /*   if(Day()<1) return(0);
         {
          flag=0; 
          Print(" 1    =");
        }*/
      //   
      if(//MaCurrent5>MaPrevious5
      //&& MathAbs (MaCurrent5-MaPrevious5)>=0.0030
      //&& MacdCurrent>MacdPrevious
      //&& MathAbs(MacdCurrentD)-(MacdPreviousD)>0,0020
      //&& StochasticMainBufferCurrent>StochasticMainBufferPrevious
      //&& MathAbs(StochasticMainBufferCurrentD)-(StochasticMainBufferPreviousD)>0,0020
      //&& 
      ROCCurrentD>ROCPreviousD
      //&& (MathAbs(ROCCurrentD)-(ROCPreviousD)>0,0020)
      && flag==1 )
        {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         //ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,40,Ask+TakeProfit*Point," ",16384,0,Green);
         //ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("   , : ",OrderOpenPrice(),
            " =",MathAbs(Bid-Ask));//,"",Day()
            //StartMA=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
           }
         else Print("     : ",GetLastError()); 
         return(0); 
        }
    }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////
 // 
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////
    total=OrdersTotal();
//int flag=1;
   if(total<1) 
     {
      //   
      if (AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
      
     // if (MathAbs(Bid-Ask)>0.0004) 
      //if (MathAbs(Bid-Ask)>100.01)
     // {
     // flag=0; 
      //Print(" =",MathAbs(Bid-Ask),"  !");
     // }
      /* if(Day()<1) return(0);
         {
          flag=0; 
          Print(" 1    =");
        }*/
       
      
 ///////////////////////////////////////////////////////////////////////////////////////   
      //   
      if(//MaCurrent5<MaPrevious5
      //&& MathAbs(MaCurrent5)-(MaPrevious5)>0.0030
      //&& MacdCurrent<MacdPrevious
      //&& MathAbs(MacdCurrentD)-(MacdPreviousD)>0,0020
      //&& StochasticMainBufferCurrent<StochasticMainBufferPrevious
      //&& MathAbs(StochasticMainBufferCurrentD)-(StochasticMainBufferPreviousD)>0,0020
      //&& 
      ROCCurrentD<ROCPreviousD
      //&& (MathAbs(ROCCurrentD)-(ROCPreviousD)>0,0020)
      && flag==1 )
        {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         //ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("   , : ",OrderOpenPrice(),
            " =",MathAbs(Bid-Ask));//,"",Day()
            //StartMA=iMA(NULL,0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
           }
         else Print("     : ",GetLastError()); 
         return(0); 
        }
      return(0);
     }
     
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////     
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   //      
         OrderSymbol()==Symbol())  //    
        {
        
         if(OrderType()==OP_BUY)   // long position is opened ( )
          // {
       
            // check for trailing stop (  )
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green); //  
                     return(0);
                    }
                 }
              }
           }
         else // go to short position ( )
           {
         
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
        
           }
       // }
     }
   return(0);
  }
  
// the end.